
clear all ;% clear all variables
close all
%============== Define global variables ===================================================
global BitRate Bits SampleRate samplesperbit  DataLength t_range f_sym Ref_Frequency

BitRate = 10e9;  
Bits = 16;
TimeWindow = Bits/BitRate;
SampleRate = BitRate*2^5;
DataLength = TimeWindow*SampleRate;
Ref_Frequency = 193.1e12; %[Hz] Physical reference optical frequency
samplesperbit = SampleRate/BitRate; % data number per bit

% time, frequency(baseband) range
t_range = 0:1/SampleRate:1/SampleRate*(DataLength-1);
f_sym = SampleRate*(-DataLength/2:(DataLength/2-1))/DataLength; %

%=========== Define a Gaussian Pulse ==========================================================
Pk = 10e-3; %[W] PeakPower
t_FWHM = 1/(3*BitRate); %[sec] Pulse Full Width at Half Maximum
t_w = t_FWHM/(2*sqrt(log(2))); %[sec] Half-width at 1/e

A_in = sqrt(Pk)*exp(-0.5*((t_range-0.5*max(t_range))/t_w).^2);
%--------------------------------------------------------------------------
%---------------- Transmission -------------------------------------
z = [10 50 100]*1e3; % [m]

%=========== Fiber Parameters +++++++++++++++++========
%S_Fiber_Length = 100e3; %[m]
%S_FiberAttenuation =  0.2e-3; %[dB/m]
%S_Dispersion = 0*16e-6;   %[s/m^2]
%S_DispersionSlope = 0*0.08e3;   %[s/m^3]

%--------------------------------------------------------------------------
for k=1:length(z)
    
[ya_t(k,:),ya_f(k,:)] = SingleModeFiber_Lin(A_in,z(k),0.2e-3,0,0);
[yb_t(k,:),yb_f(k,:)] = SingleModeFiber_Lin(A_in,z(k),0,16e-6,0);

end

figure(1)
plot(t_range,abs(ya_t(1,:)).^2,'b',t_range,abs(ya_t(2,:)).^2,'g',t_range,abs(ya_t(3,:)).^2,'r')

figure(2)
subplot 211
plot(t_range,abs(yb_t(1,:)).^2,'b',t_range,abs(yb_t(2,:)).^2,'g',t_range,abs(yb_t(3,:)).^2,'r')

subplot 212
plot(f_sym,abs(fftshift(yb_f(1,:))/SampleRate).^2,'b',f_sym,abs(fftshift(yb_f(2,:))/SampleRate).^2,'g',f_sym,abs(fftshift(yb_f(3,:))/SampleRate).^2,'r')


yb1_fwhm=FWHM(abs(yb_t(1,:)).^2)
yb2_fwhm=FWHM(abs(yb_t(2,:)).^2)
yb3_fwhm=FWHM(abs(yb_t(3,:)).^2)









